<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEquipmentDeviceNote ArrayType
 * @subpackage Arrays
 */
class ArrayOfEquipmentDeviceNote extends AbstractStructArrayBase
{
    /**
     * The EquipmentDeviceNote
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\EquipmentDeviceNote[]
     */
    public $EquipmentDeviceNote;
    /**
     * Constructor method for ArrayOfEquipmentDeviceNote
     * @uses ArrayOfEquipmentDeviceNote::setEquipmentDeviceNote()
     * @param \CustomerManagement\StructType\EquipmentDeviceNote[] $equipmentDeviceNote
     */
    public function __construct(array $equipmentDeviceNote = array())
    {
        $this
            ->setEquipmentDeviceNote($equipmentDeviceNote);
    }
    /**
     * Get EquipmentDeviceNote value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\EquipmentDeviceNote[]|null
     */
    public function getEquipmentDeviceNote()
    {
        return isset($this->EquipmentDeviceNote) ? $this->EquipmentDeviceNote : null;
    }
    /**
     * This method is responsible for validating the values passed to the setEquipmentDeviceNote method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEquipmentDeviceNote method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEquipmentDeviceNoteForArrayConstraintsFromSetEquipmentDeviceNote(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEquipmentDeviceNoteEquipmentDeviceNoteItem) {
            // validation for constraint: itemType
            if (!$arrayOfEquipmentDeviceNoteEquipmentDeviceNoteItem instanceof \CustomerManagement\StructType\EquipmentDeviceNote) {
                $invalidValues[] = is_object($arrayOfEquipmentDeviceNoteEquipmentDeviceNoteItem) ? get_class($arrayOfEquipmentDeviceNoteEquipmentDeviceNoteItem) : sprintf('%s(%s)', gettype($arrayOfEquipmentDeviceNoteEquipmentDeviceNoteItem), var_export($arrayOfEquipmentDeviceNoteEquipmentDeviceNoteItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EquipmentDeviceNote property can only contain items of type \CustomerManagement\StructType\EquipmentDeviceNote, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EquipmentDeviceNote value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\EquipmentDeviceNote[] $equipmentDeviceNote
     * @return \CustomerManagement\ArrayType\ArrayOfEquipmentDeviceNote
     */
    public function setEquipmentDeviceNote(array $equipmentDeviceNote = array())
    {
        // validation for constraint: array
        if ('' !== ($equipmentDeviceNoteArrayErrorMessage = self::validateEquipmentDeviceNoteForArrayConstraintsFromSetEquipmentDeviceNote($equipmentDeviceNote))) {
            throw new \InvalidArgumentException($equipmentDeviceNoteArrayErrorMessage, __LINE__);
        }
        if (is_null($equipmentDeviceNote) || (is_array($equipmentDeviceNote) && empty($equipmentDeviceNote))) {
            unset($this->EquipmentDeviceNote);
        } else {
            $this->EquipmentDeviceNote = $equipmentDeviceNote;
        }
        return $this;
    }
    /**
     * Add item to EquipmentDeviceNote value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\EquipmentDeviceNote $item
     * @return \CustomerManagement\ArrayType\ArrayOfEquipmentDeviceNote
     */
    public function addToEquipmentDeviceNote(\CustomerManagement\StructType\EquipmentDeviceNote $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\EquipmentDeviceNote) {
            throw new \InvalidArgumentException(sprintf('The EquipmentDeviceNote property can only contain items of type \CustomerManagement\StructType\EquipmentDeviceNote, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EquipmentDeviceNote[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\EquipmentDeviceNote|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\EquipmentDeviceNote|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\EquipmentDeviceNote|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\EquipmentDeviceNote|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\EquipmentDeviceNote|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EquipmentDeviceNote
     */
    public function getAttributeName()
    {
        return 'EquipmentDeviceNote';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \CustomerManagement\ArrayType\ArrayOfEquipmentDeviceNote
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
